diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-apf9328.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-apf9328.c
--- linux-3.0/arch/arm/mach-imx/mach-apf9328.c	2011-08-29 03:03:44.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-apf9328.c	2011-10-18 04:06:23.000000000 +0000
@@ -99,11 +99,6 @@ static struct platform_device dm9000x_de
 	}
 };
 
-/* --- SERIAL RESSOURCE --- */
-static const struct imxuart_platform_data uart0_pdata __initconst = {
-	.flags = 0,
-};
-
 static const struct imxuart_platform_data uart1_pdata __initconst = {
 	.flags = IMXUART_HAVE_RTSCTS,
 };
@@ -115,11 +110,13 @@ static struct platform_device *devices[]
 
 static void __init apf9328_init(void)
 {
+	imx1_soc_init();
+
 	mxc_gpio_setup_multiple_pins(apf9328_pins,
 			ARRAY_SIZE(apf9328_pins),
 			"APF9328");
 
-	imx1_add_imx_uart0(&uart0_pdata);
+	imx1_add_imx_uart0(NULL);
 	imx1_add_imx_uart1(&uart1_pdata);
 
 	platform_add_devices(devices, ARRAY_SIZE(devices));
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-armadillo5x0.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-armadillo5x0.c
--- linux-3.0/arch/arm/mach-imx/mach-armadillo5x0.c	2011-08-29 03:03:44.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-armadillo5x0.c	2011-10-18 04:06:23.000000000 +0000
@@ -490,6 +490,8 @@ static struct platform_device *devices[]
  */
 static void __init armadillo5x0_init(void)
 {
+	imx31_soc_init();
+
 	mxc_iomux_setup_multiple_pins(armadillo5x0_pins,
 			ARRAY_SIZE(armadillo5x0_pins), "armadillo5x0");
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-bug.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-bug.c
--- linux-3.0/arch/arm/mach-imx/mach-bug.c	2011-08-29 03:03:44.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-bug.c	2011-10-18 04:06:23.000000000 +0000
@@ -42,6 +42,8 @@ static const unsigned int bug_pins[] __i
 
 static void __init bug_board_init(void)
 {
+	imx31_soc_init();
+
 	mxc_iomux_setup_multiple_pins(bug_pins,
 				      ARRAY_SIZE(bug_pins), "uart-4");
 	imx31_add_imx_uart4(&uart_pdata);
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-cpuimx27.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-cpuimx27.c
--- linux-3.0/arch/arm/mach-imx/mach-cpuimx27.c	2011-08-29 03:03:44.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-cpuimx27.c	2011-10-18 04:06:23.000000000 +0000
@@ -250,6 +250,8 @@ __setup("otg_mode=", eukrea_cpuimx27_otg
 
 static void __init eukrea_cpuimx27_init(void)
 {
+	imx27_soc_init();
+
 	mxc_gpio_setup_multiple_pins(eukrea_cpuimx27_pins,
 		ARRAY_SIZE(eukrea_cpuimx27_pins), "CPUIMX27");
 
@@ -308,7 +310,7 @@ static struct sys_timer eukrea_cpuimx27_
 	.init = eukrea_cpuimx27_timer_init,
 };
 
-MACHINE_START(CPUIMX27, "EUKREA CPUIMX27")
+MACHINE_START(EUKREA_CPUIMX27, "EUKREA CPUIMX27")
 	.boot_params = MX27_PHYS_OFFSET + 0x100,
 	.map_io = mx27_map_io,
 	.init_early = imx27_init_early,
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-cpuimx35.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-cpuimx35.c
--- linux-3.0/arch/arm/mach-imx/mach-cpuimx35.c	2011-08-29 03:03:44.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-cpuimx35.c	2011-10-18 04:06:23.000000000 +0000
@@ -156,6 +156,8 @@ __setup("otg_mode=", eukrea_cpuimx35_otg
  */
 static void __init eukrea_cpuimx35_init(void)
 {
+	imx35_soc_init();
+
 	mxc_iomux_v3_setup_multiple_pads(eukrea_cpuimx35_pads,
 			ARRAY_SIZE(eukrea_cpuimx35_pads));
 
@@ -190,7 +192,7 @@ struct sys_timer eukrea_cpuimx35_timer =
 	.init	= eukrea_cpuimx35_timer_init,
 };
 
-MACHINE_START(EUKREA_CPUIMX35, "Eukrea CPUIMX35")
+MACHINE_START(EUKREA_CPUIMX35SD, "Eukrea CPUIMX35")
 	/* Maintainer: Eukrea Electromatique */
 	.boot_params = MX3x_PHYS_OFFSET + 0x100,
 	.map_io = mx35_map_io,
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-eukrea_cpuimx25.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-eukrea_cpuimx25.c
--- linux-3.0/arch/arm/mach-imx/mach-eukrea_cpuimx25.c	2011-08-29 03:03:44.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-eukrea_cpuimx25.c	2011-10-18 04:06:23.000000000 +0000
@@ -125,6 +125,8 @@ __setup("otg_mode=", eukrea_cpuimx25_otg
 
 static void __init eukrea_cpuimx25_init(void)
 {
+	imx25_soc_init();
+
 	if (mxc_iomux_v3_setup_multiple_pads(eukrea_cpuimx25_pads,
 			ARRAY_SIZE(eukrea_cpuimx25_pads)))
 		printk(KERN_ERR "error setting cpuimx25 pads !\n");
@@ -159,7 +161,7 @@ static struct sys_timer eukrea_cpuimx25_
 	.init   = eukrea_cpuimx25_timer_init,
 };
 
-MACHINE_START(EUKREA_CPUIMX25, "Eukrea CPUIMX25")
+MACHINE_START(EUKREA_CPUIMX25SD, "Eukrea CPUIMX25")
 	/* Maintainer: Eukrea Electromatique */
 	.boot_params = MX25_PHYS_OFFSET + 0x100,
 	.map_io = mx25_map_io,
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-imx27_visstrim_m10.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-imx27_visstrim_m10.c
--- linux-3.0/arch/arm/mach-imx/mach-imx27_visstrim_m10.c	2011-08-29 03:03:44.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-imx27_visstrim_m10.c	2011-10-18 04:06:23.000000000 +0000
@@ -30,11 +30,12 @@
 #include <linux/input.h>
 #include <linux/gpio.h>
 #include <linux/delay.h>
+#include <sound/tlv320aic32x4.h>
 #include <asm/mach-types.h>
 #include <asm/mach/arch.h>
 #include <asm/mach/time.h>
 #include <mach/common.h>
-#include <mach/iomux.h>
+#include <mach/iomux-mx27.h>
 
 #include "devices-imx27.h"
 
@@ -196,6 +197,17 @@ static struct pca953x_platform_data viss
 	.invert = 0,
 };
 
+static struct aic32x4_pdata visstrim_m10_aic32x4_pdata = {
+	.power_cfg = AIC32X4_PWR_MICBIAS_2075_LDOIN |
+		     AIC32X4_PWR_AVDD_DVDD_WEAK_DISABLE |
+		     AIC32X4_PWR_AIC32X4_LDO_ENABLE |
+		     AIC32X4_PWR_CMMODE_LDOIN_RANGE_18_36 |
+		     AIC32X4_PWR_CMMODE_HP_LDOIN_POWERED,
+	.micpga_routing = AIC32X4_MICPGA_ROUTE_LMIC_IN2R_10K |
+			 AIC32X4_MICPGA_ROUTE_RMIC_IN1L_10K,
+	.swapdacs = false,
+};
+
 static struct i2c_board_info visstrim_m10_i2c_devices[] = {
 	{
 		I2C_BOARD_INFO("pca9555", 0x20),
@@ -203,6 +215,7 @@ static struct i2c_board_info visstrim_m1
 	},
 	{
 		I2C_BOARD_INFO("tlv320aic32x4", 0x18),
+		.platform_data = &visstrim_m10_aic32x4_pdata,
 	}
 };
 
@@ -231,6 +244,8 @@ static void __init visstrim_m10_board_in
 {
 	int ret;
 
+	imx27_soc_init();
+
 	ret = mxc_gpio_setup_multiple_pins(visstrim_m10_pins,
 			ARRAY_SIZE(visstrim_m10_pins), "VISSTRIM_M10");
 	if (ret)
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-imx27ipcam.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-imx27ipcam.c
--- linux-3.0/arch/arm/mach-imx/mach-imx27ipcam.c	2011-06-22 15:07:07.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-imx27ipcam.c	2011-10-18 04:06:23.000000000 +0000
@@ -50,6 +50,8 @@ static const int mx27ipcam_pins[] __init
 
 static void __init mx27ipcam_init(void)
 {
+	imx27_soc_init();
+
 	mxc_gpio_setup_multiple_pins(mx27ipcam_pins, ARRAY_SIZE(mx27ipcam_pins),
 		"mx27ipcam");
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-imx27lite.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-imx27lite.c
--- linux-3.0/arch/arm/mach-imx/mach-imx27lite.c	2011-06-22 15:07:07.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-imx27lite.c	2011-10-18 04:06:23.000000000 +0000
@@ -59,6 +59,8 @@ static const struct imxuart_platform_dat
 
 static void __init mx27lite_init(void)
 {
+	imx27_soc_init();
+
 	mxc_gpio_setup_multiple_pins(mx27lite_pins, ARRAY_SIZE(mx27lite_pins),
 		"imx27lite");
 	imx27_add_imx_uart0(&uart_pdata);
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-kzm_arm11_01.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-kzm_arm11_01.c
--- linux-3.0/arch/arm/mach-imx/mach-kzm_arm11_01.c	2011-08-29 03:03:44.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-kzm_arm11_01.c	2011-10-18 04:06:23.000000000 +0000
@@ -223,6 +223,8 @@ static int kzm_pins[] __initdata = {
  */
 static void __init kzm_board_init(void)
 {
+	imx31_soc_init();
+
 	mxc_iomux_setup_multiple_pins(kzm_pins,
 				      ARRAY_SIZE(kzm_pins), "kzm");
 	kzm_init_ext_uart();
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-mx1ads.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx1ads.c
--- linux-3.0/arch/arm/mach-imx/mach-mx1ads.c	2011-08-29 03:03:44.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx1ads.c	2011-10-18 04:06:23.000000000 +0000
@@ -115,6 +115,8 @@ static struct i2c_board_info mx1ads_i2c_
  */
 static void __init mx1ads_init(void)
 {
+	imx1_soc_init();
+
 	mxc_gpio_setup_multiple_pins(mx1ads_pins,
 		ARRAY_SIZE(mx1ads_pins), "mx1ads");
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-mx21ads.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx21ads.c
--- linux-3.0/arch/arm/mach-imx/mach-mx21ads.c	2011-08-29 03:03:44.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx21ads.c	2011-10-18 04:06:23.000000000 +0000
@@ -279,6 +279,8 @@ static struct platform_device *platform_
 
 static void __init mx21ads_board_init(void)
 {
+	imx21_soc_init();
+
 	mxc_gpio_setup_multiple_pins(mx21ads_pins, ARRAY_SIZE(mx21ads_pins),
 			"mx21ads");
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-mx25_3ds.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx25_3ds.c
--- linux-3.0/arch/arm/mach-imx/mach-mx25_3ds.c	2011-08-29 03:03:44.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx25_3ds.c	2011-10-18 04:06:23.000000000 +0000
@@ -215,10 +215,14 @@ static const struct imxi2c_platform_data
 static const struct esdhc_platform_data mx25pdk_esdhc_pdata __initconst = {
 	.wp_gpio = SD1_GPIO_WP,
 	.cd_gpio = SD1_GPIO_CD,
+	.wp_type = ESDHC_WP_GPIO,
+	.cd_type = ESDHC_CD_GPIO,
 };
 
 static void __init mx25pdk_init(void)
 {
+	imx25_soc_init();
+
 	mxc_iomux_v3_setup_multiple_pads(mx25pdk_pads,
 			ARRAY_SIZE(mx25pdk_pads));
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-mx27_3ds.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx27_3ds.c
--- linux-3.0/arch/arm/mach-imx/mach-mx27_3ds.c	2011-06-22 15:07:07.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx27_3ds.c	2011-10-18 04:06:23.000000000 +0000
@@ -29,6 +29,7 @@
 #include <linux/mfd/mc13783.h>
 #include <linux/spi/spi.h>
 #include <linux/regulator/machine.h>
+#include <linux/spi/l4f00242t03.h>
 
 #include <asm/mach-types.h>
 #include <asm/mach/arch.h>
@@ -42,10 +43,15 @@
 
 #include "devices-imx27.h"
 
-#define SD1_EN_GPIO (GPIO_PORTB + 25)
-#define OTG_PHY_RESET_GPIO (GPIO_PORTB + 23)
-#define SPI2_SS0 (GPIO_PORTD + 21)
-#define EXPIO_PARENT_INT	(MXC_INTERNAL_IRQS + GPIO_PORTC + 28)
+#define SD1_EN_GPIO		IMX_GPIO_NR(2, 25)
+#define OTG_PHY_RESET_GPIO	IMX_GPIO_NR(2, 23)
+#define SPI2_SS0		IMX_GPIO_NR(4, 21)
+#define EXPIO_PARENT_INT	gpio_to_irq(IMX_GPIO_NR(3, 28))
+#define PMIC_INT		IMX_GPIO_NR(3, 14)
+#define SPI1_SS0		IMX_GPIO_NR(4, 28)
+#define SD1_CD			IMX_GPIO_NR(2, 26)
+#define LCD_RESET		IMX_GPIO_NR(1, 3)
+#define LCD_ENABLE		IMX_GPIO_NR(1, 31)
 
 static const int mx27pdk_pins[] __initconst = {
 	/* UART1 */
@@ -94,13 +100,47 @@ static const int mx27pdk_pins[] __initco
 	PE2_PF_USBOTG_DIR,
 	PE24_PF_USBOTG_CLK,
 	PE25_PF_USBOTG_DATA7,
+	/* CSPI1 */
+	PD31_PF_CSPI1_MOSI,
+	PD30_PF_CSPI1_MISO,
+	PD29_PF_CSPI1_SCLK,
+	PD25_PF_CSPI1_RDY,
+	SPI1_SS0 | GPIO_GPIO | GPIO_OUT,
 	/* CSPI2 */
 	PD22_PF_CSPI2_SCLK,
 	PD23_PF_CSPI2_MISO,
 	PD24_PF_CSPI2_MOSI,
+	SPI2_SS0 | GPIO_GPIO | GPIO_OUT,
 	/* I2C1 */
 	PD17_PF_I2C_DATA,
 	PD18_PF_I2C_CLK,
+	/* PMIC INT */
+	PMIC_INT | GPIO_GPIO | GPIO_IN,
+	/* LCD */
+	PA5_PF_LSCLK,
+	PA6_PF_LD0,
+	PA7_PF_LD1,
+	PA8_PF_LD2,
+	PA9_PF_LD3,
+	PA10_PF_LD4,
+	PA11_PF_LD5,
+	PA12_PF_LD6,
+	PA13_PF_LD7,
+	PA14_PF_LD8,
+	PA15_PF_LD9,
+	PA16_PF_LD10,
+	PA17_PF_LD11,
+	PA18_PF_LD12,
+	PA19_PF_LD13,
+	PA20_PF_LD14,
+	PA21_PF_LD15,
+	PA22_PF_LD16,
+	PA23_PF_LD17,
+	PA28_PF_HSYNC,
+	PA29_PF_VSYNC,
+	PA30_PF_CONTRAST,
+	LCD_ENABLE | GPIO_GPIO | GPIO_OUT,
+	LCD_RESET | GPIO_GPIO | GPIO_OUT,
 };
 
 static const struct imxuart_platform_data uart_pdata __initconst = {
@@ -131,13 +171,13 @@ static const struct matrix_keymap_data m
 static int mx27_3ds_sdhc1_init(struct device *dev, irq_handler_t detect_irq,
 				void *data)
 {
-	return request_irq(IRQ_GPIOB(26), detect_irq, IRQF_TRIGGER_FALLING |
-			IRQF_TRIGGER_RISING, "sdhc1-card-detect", data);
+	return request_irq(gpio_to_irq(SD1_CD), detect_irq,
+	IRQF_TRIGGER_FALLING | IRQF_TRIGGER_RISING, "sdhc1-card-detect", data);
 }
 
 static void mx27_3ds_sdhc1_exit(struct device *dev, void *data)
 {
-	free_irq(IRQ_GPIOB(26), data);
+	free_irq(gpio_to_irq(SD1_CD), data);
 }
 
 static const struct imxmmc_platform_data sdhc1_pdata __initconst = {
@@ -193,6 +233,13 @@ static int __init mx27_3ds_otg_mode(char
 __setup("otg_mode=", mx27_3ds_otg_mode);
 
 /* Regulators */
+static struct regulator_init_data gpo_init = {
+	.constraints = {
+		.boot_on = 1,
+		.always_on = 1,
+	}
+};
+
 static struct regulator_consumer_supply vmmc1_consumers[] = {
 	REGULATOR_SUPPLY("lcd_2v8", NULL),
 };
@@ -201,7 +248,9 @@ static struct regulator_init_data vmmc1_
 	.constraints = {
 		.min_uV	= 2800000,
 		.max_uV = 2800000,
-		.valid_ops_mask = REGULATOR_CHANGE_VOLTAGE,
+		.apply_uV = 1,
+		.valid_ops_mask = REGULATOR_CHANGE_VOLTAGE |
+				  REGULATOR_CHANGE_STATUS,
 	},
 	.num_consumer_supplies = ARRAY_SIZE(vmmc1_consumers),
 	.consumer_supplies = vmmc1_consumers,
@@ -228,6 +277,12 @@ static struct mc13xxx_regulator_init_dat
 	}, {
 		.id = MC13783_REG_VGEN,
 		.init_data = &vgen_init,
+	}, {
+		.id = MC13783_REG_GPO1, /* Turn on 1.8V */
+		.init_data = &gpo_init,
+	}, {
+		.id = MC13783_REG_GPO3, /* Turn on 3.3V */
+		.init_data = &gpo_init,
 	},
 };
 
@@ -238,15 +293,63 @@ static struct mc13xxx_platform_data mc13
 		.num_regulators = ARRAY_SIZE(mx27_3ds_regulators),
 
 	},
-	.flags  = MC13783_USE_REGULATOR,
+	.flags  = MC13783_USE_REGULATOR | MC13783_USE_TOUCHSCREEN |
+	MC13783_USE_RTC,
 };
 
 /* SPI */
-static int spi2_internal_chipselect[] = {SPI2_SS0};
+static int spi1_chipselect[] = {SPI1_SS0};
+
+static const struct spi_imx_master spi1_pdata __initconst = {
+	.chipselect	= spi1_chipselect,
+	.num_chipselect	= ARRAY_SIZE(spi1_chipselect),
+};
+
+static int spi2_chipselect[] = {SPI2_SS0};
 
 static const struct spi_imx_master spi2_pdata __initconst = {
-	.chipselect	= spi2_internal_chipselect,
-	.num_chipselect	= ARRAY_SIZE(spi2_internal_chipselect),
+	.chipselect	= spi2_chipselect,
+	.num_chipselect	= ARRAY_SIZE(spi2_chipselect),
+};
+
+static struct imx_fb_videomode mx27_3ds_modes[] = {
+	{	/* 480x640 @ 60 Hz */
+		.mode = {
+			.name		= "Epson-VGA",
+			.refresh	= 60,
+			.xres		= 480,
+			.yres		= 640,
+			.pixclock	= 41701,
+			.left_margin	= 20,
+			.right_margin	= 41,
+			.upper_margin	= 10,
+			.lower_margin	= 5,
+			.hsync_len	= 20,
+			.vsync_len	= 10,
+			.sync		= FB_SYNC_OE_ACT_HIGH |
+						FB_SYNC_CLK_INVERT,
+			.vmode		= FB_VMODE_NONINTERLACED,
+			.flag		= 0,
+		},
+		.bpp		= 16,
+		.pcr		= 0xFAC08B82,
+	},
+};
+
+static const struct imx_fb_platform_data mx27_3ds_fb_data __initconst = {
+	.mode = mx27_3ds_modes,
+	.num_modes = ARRAY_SIZE(mx27_3ds_modes),
+	.pwmr		= 0x00A903FF,
+	.lscr1		= 0x00120300,
+	.dmacr		= 0x00020010,
+};
+
+/* LCD */
+static struct l4f00242t03_pdata mx27_3ds_lcd_pdata = {
+	.reset_gpio		= LCD_RESET,
+	.data_enable_gpio	= LCD_ENABLE,
+	.core_supply		= "lcd_2v8",
+	.io_supply		= "vdd_lcdio",
 };
 
 static struct spi_board_info mx27_3ds_spi_devs[] __initdata = {
@@ -256,8 +359,14 @@ static struct spi_board_info mx27_3ds_sp
 		.bus_num	= 1,
 		.chip_select	= 0, /* SS0 */
 		.platform_data	= &mc13783_pdata,
-		.irq = IRQ_GPIOC(14),
+		.irq = gpio_to_irq(PMIC_INT),
 		.mode = SPI_CS_HIGH,
+	}, {
+		.modalias	= "l4f00242t03",
+		.max_speed_hz	= 5000000,
+		.bus_num	= 0,
+		.chip_select	= 0, /* SS0 */
+		.platform_data	= &mx27_3ds_lcd_pdata,
 	},
 };
 
@@ -267,6 +376,8 @@ static const struct imxi2c_platform_data
 
 static void __init mx27pdk_init(void)
 {
+	imx27_soc_init();
+
 	mxc_gpio_setup_multiple_pins(mx27pdk_pins, ARRAY_SIZE(mx27pdk_pins),
 		"mx27pdk");
 	mx27_3ds_sdhc1_enable_level_translator();
@@ -289,12 +400,14 @@ static void __init mx27pdk_init(void)
 		imx27_add_fsl_usb2_udc(&otg_device_pdata);
 
 	imx27_add_spi_imx1(&spi2_pdata);
+	imx27_add_spi_imx0(&spi1_pdata);
 	spi_register_board_info(mx27_3ds_spi_devs,
 						ARRAY_SIZE(mx27_3ds_spi_devs));
 
 	if (mxc_expio_init(MX27_CS5_BASE_ADDR, EXPIO_PARENT_INT))
 		pr_warn("Init of the debugboard failed, all devices on the debugboard are unusable.\n");
 	imx27_add_imx_i2c(0, &mx27_3ds_i2c0_data);
+	imx27_add_imx_fb(&mx27_3ds_fb_data);
 }
 
 static void __init mx27pdk_timer_init(void)
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-mx27ads.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx27ads.c
--- linux-3.0/arch/arm/mach-imx/mach-mx27ads.c	2011-08-29 03:03:44.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx27ads.c	2011-10-18 04:06:23.000000000 +0000
@@ -288,6 +288,8 @@ static const struct imxuart_platform_dat
 
 static void __init mx27ads_board_init(void)
 {
+	imx27_soc_init();
+
 	mxc_gpio_setup_multiple_pins(mx27ads_pins, ARRAY_SIZE(mx27ads_pins),
 			"mx27ads");
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-mx31_3ds.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx31_3ds.c
--- linux-3.0/arch/arm/mach-imx/mach-mx31_3ds.c	2011-08-29 03:03:44.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx31_3ds.c	2011-10-18 04:06:23.000000000 +0000
@@ -13,6 +13,7 @@
  */
 
 #include <linux/delay.h>
+#include <linux/dma-mapping.h>
 #include <linux/types.h>
 #include <linux/init.h>
 #include <linux/clk.h>
@@ -53,11 +54,8 @@ static int mx31_3ds_pins[] = {
 	MX31_PIN_RXD1__RXD1,
 	IOMUX_MODE(MX31_PIN_GPIO1_1, IOMUX_CONFIG_GPIO),
 	/*SPI0*/
-	MX31_PIN_CSPI1_SCLK__SCLK,
-	MX31_PIN_CSPI1_MOSI__MOSI,
-	MX31_PIN_CSPI1_MISO__MISO,
-	MX31_PIN_CSPI1_SPI_RDY__SPI_RDY,
-	MX31_PIN_CSPI1_SS2__SS2, /* CS for LCD */
+	IOMUX_MODE(MX31_PIN_DSR_DCE1, IOMUX_CONFIG_ALT1),
+	IOMUX_MODE(MX31_PIN_RI_DCE1, IOMUX_CONFIG_ALT1),
 	/* SPI 1 */
 	MX31_PIN_CSPI2_SCLK__SCLK,
 	MX31_PIN_CSPI2_MOSI__MOSI,
@@ -689,6 +687,11 @@ static void __init mx31_3ds_init(void)
 {
 	int ret;
 
+	imx31_soc_init();
+
+	/* Configure SPI1 IOMUX */
+	mxc_iomux_set_gpr(MUX_PGP_CSPI_BB, true);
+
 	mxc_iomux_setup_multiple_pins(mx31_3ds_pins, ARRAY_SIZE(mx31_3ds_pins),
 				      "mx31_3ds");
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-mx31ads.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx31ads.c
--- linux-3.0/arch/arm/mach-imx/mach-mx31ads.c	2011-08-29 03:03:44.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx31ads.c	2011-10-18 04:06:23.000000000 +0000
@@ -468,7 +468,7 @@ static struct i2c_board_info __initdata
 #endif
 };
 
-static void mxc_init_i2c(void)
+static void __init mxc_init_i2c(void)
 {
 	i2c_register_board_info(1, mx31ads_i2c1_devices,
 				ARRAY_SIZE(mx31ads_i2c1_devices));
@@ -486,7 +486,7 @@ static unsigned int ssi_pins[] = {
 	MX31_PIN_STXD5__STXD5,
 };
 
-static void mxc_init_audio(void)
+static void __init mxc_init_audio(void)
 {
 	imx31_add_imx_ssi(0, NULL);
 	mxc_iomux_setup_multiple_pins(ssi_pins, ARRAY_SIZE(ssi_pins), "ssi");
@@ -516,6 +516,8 @@ static void __init mx31ads_init_irq(void
 
 static void __init mx31ads_init(void)
 {
+	imx31_soc_init();
+
 	mxc_init_extuart();
 	mxc_init_imx_uart();
 	mxc_init_i2c();
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-mx31lilly.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx31lilly.c
--- linux-3.0/arch/arm/mach-imx/mach-mx31lilly.c	2011-08-29 03:03:44.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx31lilly.c	2011-10-18 04:06:23.000000000 +0000
@@ -192,7 +192,7 @@ static struct mxc_usbh_platform_data usb
 	.portsc	= MXC_EHCI_MODE_ULPI | MXC_EHCI_UTMI_8BIT,
 };
 
-static void lilly1131_usb_init(void)
+static void __init lilly1131_usb_init(void)
 {
 	imx31_add_mxc_ehci_hs(1, &usbh1_pdata);
 
@@ -243,6 +243,8 @@ core_param(mx31lilly_baseboard, mx31lill
 
 static void __init mx31lilly_board_init(void)
 {
+	imx31_soc_init();
+
 	switch (mx31lilly_baseboard) {
 	case MX31LILLY_NOBOARD:
 		break;
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-mx31lite.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx31lite.c
--- linux-3.0/arch/arm/mach-imx/mach-mx31lite.c	2011-08-29 03:03:44.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx31lite.c	2011-10-18 04:06:23.000000000 +0000
@@ -230,6 +230,8 @@ static void __init mx31lite_init(void)
 {
 	int ret;
 
+	imx31_soc_init();
+
 	switch (mx31lite_baseboard) {
 	case MX31LITE_NOBOARD:
 		break;
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-mx31moboard.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx31moboard.c
--- linux-3.0/arch/arm/mach-imx/mach-mx31moboard.c	2011-08-29 03:03:45.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx31moboard.c	2011-10-18 04:06:23.000000000 +0000
@@ -425,7 +425,7 @@ static int __init moboard_usbh2_init(voi
 	return 0;
 }
 
-static struct gpio_led mx31moboard_leds[] = {
+static const struct gpio_led mx31moboard_leds[] __initconst = {
 	{
 		.name	= "coreboard-led-0:red:running",
 		.default_trigger = "heartbeat",
@@ -442,26 +442,17 @@ static struct gpio_led mx31moboard_leds[
 	},
 };
 
-static struct gpio_led_platform_data mx31moboard_led_pdata = {
+static const struct gpio_led_platform_data mx31moboard_led_pdata __initconst = {
 	.num_leds	= ARRAY_SIZE(mx31moboard_leds),
 	.leds		= mx31moboard_leds,
 };
 
-static struct platform_device mx31moboard_leds_device = {
-	.name	= "leds-gpio",
-	.id	= -1,
-	.dev	= {
-		.platform_data = &mx31moboard_led_pdata,
-	},
-};
-
 static const struct ipu_platform_data mx3_ipu_data __initconst = {
 	.irq_base = MXC_IPU_IRQ_START,
 };
 
 static struct platform_device *devices[] __initdata = {
 	&mx31moboard_flash,
-	&mx31moboard_leds_device,
 };
 
 static struct mx3_camera_pdata camera_pdata __initdata = {
@@ -507,10 +498,13 @@ core_param(mx31moboard_baseboard, mx31mo
  */
 static void __init mx31moboard_init(void)
 {
+	imx31_soc_init();
+
 	mxc_iomux_setup_multiple_pins(moboard_pins, ARRAY_SIZE(moboard_pins),
 		"moboard");
 
 	platform_add_devices(devices, ARRAY_SIZE(devices));
+	gpio_led_register_device(-1, &mx31moboard_led_pdata);
 
 	imx31_add_imx_uart0(&uart0_pdata);
 	imx31_add_imx_uart4(&uart4_pdata);
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-mx35_3ds.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx35_3ds.c
--- linux-3.0/arch/arm/mach-imx/mach-mx35_3ds.c	2011-08-29 03:03:45.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mx35_3ds.c	2011-10-18 04:06:23.000000000 +0000
@@ -43,7 +43,7 @@
 
 #include "devices-imx35.h"
 
-#define EXPIO_PARENT_INT	(MXC_INTERNAL_IRQS + GPIO_PORTA + 1)
+#define EXPIO_PARENT_INT	gpio_to_irq(IMX_GPIO_NR(1, 1))
 
 static const struct imxuart_platform_data uart_pdata __initconst = {
 	.flags = IMXUART_HAVE_RTSCTS,
@@ -179,6 +179,8 @@ static const struct imxi2c_platform_data
  */
 static void __init mx35_3ds_init(void)
 {
+	imx35_soc_init();
+
 	mxc_iomux_v3_setup_multiple_pads(mx35pdk_pads, ARRAY_SIZE(mx35pdk_pads));
 
 	imx35_add_fec(NULL);
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-mxt_td60.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mxt_td60.c
--- linux-3.0/arch/arm/mach-imx/mach-mxt_td60.c	2011-08-29 03:03:45.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-mxt_td60.c	2011-10-18 04:06:23.000000000 +0000
@@ -233,6 +233,8 @@ static const struct imxuart_platform_dat
 
 static void __init mxt_td60_board_init(void)
 {
+	imx27_soc_init();
+
 	mxc_gpio_setup_multiple_pins(mxt_td60_pins, ARRAY_SIZE(mxt_td60_pins),
 			"MXT_TD60");
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-pca100.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-pca100.c
--- linux-3.0/arch/arm/mach-imx/mach-pca100.c	2011-08-29 03:03:45.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-pca100.c	2011-10-18 04:06:23.000000000 +0000
@@ -357,6 +357,8 @@ static void __init pca100_init(void)
 {
 	int ret;
 
+	imx27_soc_init();
+
 	/* SSI unit */
 	mxc_audmux_v1_configure_port(MX27_AUDMUX_HPCR1_SSI0,
 				  MXC_AUDMUX_V1_PCR_SYN | /* 4wire mode */
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-pcm037.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-pcm037.c
--- linux-3.0/arch/arm/mach-imx/mach-pcm037.c	2011-08-29 03:03:45.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-pcm037.c	2011-10-18 04:06:23.000000000 +0000
@@ -576,6 +576,8 @@ static void __init pcm037_init(void)
 {
 	int ret;
 
+	imx31_soc_init();
+
 	mxc_iomux_set_gpr(MUX_PGP_UH2, 1);
 
 	mxc_iomux_setup_multiple_pins(pcm037_pins, ARRAY_SIZE(pcm037_pins),
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-pcm038.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-pcm038.c
--- linux-3.0/arch/arm/mach-imx/mach-pcm038.c	2011-08-29 03:03:45.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-pcm038.c	2011-10-18 04:06:23.000000000 +0000
@@ -295,6 +295,8 @@ static const struct mxc_usbh_platform_da
 
 static void __init pcm038_init(void)
 {
+	imx27_soc_init();
+
 	mxc_gpio_setup_multiple_pins(pcm038_pins, ARRAY_SIZE(pcm038_pins),
 			"PCM038");
 
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-pcm043.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-pcm043.c
--- linux-3.0/arch/arm/mach-imx/mach-pcm043.c	2011-08-29 03:03:45.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-pcm043.c	2011-10-18 04:06:23.000000000 +0000
@@ -349,6 +349,8 @@ __setup("otg_mode=", pcm043_otg_mode);
 static struct esdhc_platform_data sd1_pdata = {
 	.wp_gpio = SD1_GPIO_WP,
 	.cd_gpio = SD1_GPIO_CD,
+	.wp_type = ESDHC_WP_GPIO,
+	.cd_type = ESDHC_CD_GPIO,
 };
 
 /*
@@ -356,6 +358,8 @@ static struct esdhc_platform_data sd1_pd
  */
 static void __init pcm043_init(void)
 {
+	imx35_soc_init();
+
 	mxc_iomux_v3_setup_multiple_pads(pcm043_pads, ARRAY_SIZE(pcm043_pads));
 
 	mxc_audmux_v2_configure_port(3,
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-qong.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-qong.c
--- linux-3.0/arch/arm/mach-imx/mach-qong.c	2011-08-29 03:03:45.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-qong.c	2011-10-18 04:06:23.000000000 +0000
@@ -244,6 +244,8 @@ static void __init qong_init_fpga(void)
  */
 static void __init qong_init(void)
 {
+	imx31_soc_init();
+
 	mxc_init_imx_uart();
 	qong_init_nor_mtd();
 	qong_init_fpga();
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-scb9328.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-scb9328.c
--- linux-3.0/arch/arm/mach-imx/mach-scb9328.c	2011-06-22 15:07:07.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-scb9328.c	2011-10-18 04:06:23.000000000 +0000
@@ -101,21 +101,7 @@ static const int mxc_uart1_pins[] = {
 	PC12_PF_UART1_RXD,
 };
 
-static int uart1_mxc_init(struct platform_device *pdev)
-{
-	return mxc_gpio_setup_multiple_pins(mxc_uart1_pins,
-			ARRAY_SIZE(mxc_uart1_pins), "UART1");
-}
-
-static void uart1_mxc_exit(struct platform_device *pdev)
-{
-	mxc_gpio_release_multiple_pins(mxc_uart1_pins,
-			ARRAY_SIZE(mxc_uart1_pins));
-}
-
 static const struct imxuart_platform_data uart_pdata __initconst = {
-	.init = uart1_mxc_init,
-	.exit = uart1_mxc_exit,
 	.flags = IMXUART_HAVE_RTSCTS,
 };
 
@@ -129,6 +115,11 @@ static struct platform_device *devices[]
  */
 static void __init scb9328_init(void)
 {
+	imx1_soc_init();
+
+	mxc_gpio_setup_multiple_pins(mxc_uart1_pins,
+			ARRAY_SIZE(mxc_uart1_pins), "UART1");
+
 	imx1_add_imx_uart0(&uart_pdata);
 
 	printk(KERN_INFO"Scb9328: Adding devices\n");
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mach-vpr200.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-vpr200.c
--- linux-3.0/arch/arm/mach-imx/mach-vpr200.c	2011-08-29 03:03:45.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mach-vpr200.c	2011-10-18 04:06:23.000000000 +0000
@@ -267,6 +267,8 @@ static struct platform_device *devices[]
  */
 static void __init vpr200_board_init(void)
 {
+	imx35_soc_init();
+
 	mxc_iomux_v3_setup_multiple_pads(vpr200_pads, ARRAY_SIZE(vpr200_pads));
 
 	imx35_add_fec(NULL);
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mm-imx1.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mm-imx1.c
--- linux-3.0/arch/arm/mach-imx/mm-imx1.c	2011-06-22 15:07:07.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mm-imx1.c	2011-10-18 04:06:23.000000000 +0000
@@ -23,7 +23,6 @@
 
 #include <mach/common.h>
 #include <mach/hardware.h>
-#include <mach/gpio.h>
 #include <mach/irqs.h>
 #include <mach/iomux-v1.h>
 
@@ -44,15 +43,19 @@ void __init imx1_init_early(void)
 			MX1_NUM_GPIO_PORT);
 }
 
-static struct mxc_gpio_port imx1_gpio_ports[] = {
-	DEFINE_IMX_GPIO_PORT_IRQ(MX1, 0, 1, MX1_GPIO_INT_PORTA),
-	DEFINE_IMX_GPIO_PORT_IRQ(MX1, 1, 2, MX1_GPIO_INT_PORTB),
-	DEFINE_IMX_GPIO_PORT_IRQ(MX1, 2, 3, MX1_GPIO_INT_PORTC),
-	DEFINE_IMX_GPIO_PORT_IRQ(MX1, 3, 4, MX1_GPIO_INT_PORTD),
-};
-
 void __init mx1_init_irq(void)
 {
 	mxc_init_irq(MX1_IO_ADDRESS(MX1_AVIC_BASE_ADDR));
-	mxc_gpio_init(imx1_gpio_ports,	ARRAY_SIZE(imx1_gpio_ports));
+}
+
+void __init imx1_soc_init(void)
+{
+	mxc_register_gpio("imx1-gpio", 0, MX1_GPIO1_BASE_ADDR, SZ_256,
+						MX1_GPIO_INT_PORTA, 0);
+	mxc_register_gpio("imx1-gpio", 1, MX1_GPIO2_BASE_ADDR, SZ_256,
+						MX1_GPIO_INT_PORTB, 0);
+	mxc_register_gpio("imx1-gpio", 2, MX1_GPIO3_BASE_ADDR, SZ_256,
+						MX1_GPIO_INT_PORTC, 0);
+	mxc_register_gpio("imx1-gpio", 3, MX1_GPIO4_BASE_ADDR, SZ_256,
+						MX1_GPIO_INT_PORTD, 0);
 }
diff -NurpP --minimal linux-3.0/arch/arm/mach-imx/mm-imx21.c torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mm-imx21.c
--- linux-3.0/arch/arm/mach-imx/mm-imx21.c	2011-06-22 15:07:07.000000000 +0000
+++ torvalds-linux-v3.1-rc10/arch/arm/mach-imx/mm-imx21.c	2011-10-18 04:06:23.000000000 +0000
@@ -22,9 +22,9 @@
 #include <linux/init.h>
 #include <mach/hardware.h>
 #include <mach/common.h>
+#include <mach/devices-common.h>
 #include <asm/pgtable.h>
 #include <asm/mach/map.h>
-#include <mach/gpio.h>
 #include <mach/irqs.h>
 #include <mach/iomux-v1.h>
 
@@ -70,17 +70,19 @@ void __init imx21_init_early(void)
 			MX21_NUM_GPIO_PORT);
 }
 
-static struct mxc_gpio_port imx21_gpio_ports[] = {
-	DEFINE_IMX_GPIO_PORT_IRQ(MX21, 0, 1, MX21_INT_GPIO),
-	DEFINE_IMX_GPIO_PORT(MX21, 1, 2),
-	DEFINE_IMX_GPIO_PORT(MX21, 2, 3),
-	DEFINE_IMX_GPIO_PORT(MX21, 3, 4),
-	DEFINE_IMX_GPIO_PORT(MX21, 4, 5),
-	DEFINE_IMX_GPIO_PORT(MX21, 5, 6),
-};
-
 void __init mx21_init_irq(void)
 {
 	mxc_init_irq(MX21_IO_ADDRESS(MX21_AVIC_BASE_ADDR));
-	mxc_gpio_init(imx21_gpio_ports,	ARRAY_SIZE(imx21_gpio_ports));
+}
+
+void __init imx21_soc_init(void)
+{
+	mxc_register_gpio("imx21-gpio", 0, MX21_GPIO1_BASE_ADDR, SZ_256, MX21_INT_GPIO, 0);
+	mxc_register_gpio("imx21-gpio", 1, MX21_GPIO2_BASE_ADDR, SZ_256, MX21_INT_GPIO, 0);
+	mxc_register_gpio("imx21-gpio", 2, MX21_GPIO3_BASE_ADDR, SZ_256, MX21_INT_GPIO, 0);
+	mxc_register_gpio("imx21-gpio", 3, MX21_GPIO4_BASE_ADDR, SZ_256, MX21_INT_GPIO, 0);
+	mxc_register_gpio("imx21-gpio", 4, MX21_GPIO5_BASE_ADDR, SZ_256, MX21_INT_GPIO, 0);
+	mxc_register_gpio("imx21-gpio", 5, MX21_GPIO6_BASE_ADDR, SZ_256, MX21_INT_GPIO, 0);
+
+	imx_add_imx_dma();
 }
